"use strict";
this.name           = "SC equipment events";
this.author         = "Lone_Wolf";
this.copyright      = "(C) 2011-2012, 2014-2015 Lone_Wolf.";
this.licence        = "CC-by-SA 4.0";
this.description    = "SC equipment event handler";
this.version        = "1.12";

this.activated = function()
  {
    if ( worldScripts["Shield Cycler"].startUp ) { worldScripts["Shield Cycler"].startUp(); };
    // Triggered by pressing n-key while shieldcycler is primed
    // is only called when player has a manual configurator installed and player presses n-key while device is primed
    // verify if oxp is active, just-in-case
    if ( worldScripts["Shield Cycler"]._sc_settings.general.disabled ) { return; };
    // verify if shield cycler devices are active, just in case
    if ( worldScripts["Shield Cycler"]._sc_settings.general.sc_disabled ) { return; };
    var loop_ready = false;
    var new_config = worldScripts["Shield Cycler"]._sc_settings.sc.current_configuration;
    do
      {
	new_config = ( new_config + 1 ) % worldScripts["Shield Cycler"]._sc_const.cycle.count;
	loop_ready = !( worldScripts["Shield Cycler"]._sc_settings.sc.cycler_mask & Math.pow(2, new_config) );
       }
    while ( loop_ready );
    worldScripts["Shield Cycler"]._sc_settings.sc.current_configuration = new_config;
    var error = worldScripts["SC Core"]._sc_sc_adjust(true);
    if (error < 0 )
      {
	player.commsMessage("Error - check latest log",10);
	log(this.name,"error while cycling settings");
      };
  };

this.mode = function()
  {
    if ( worldScripts["Shield Cycler"].startUp ) { worldScripts["Shield Cycler"].startUp(); };
    // verify if oxp is active
    if ( worldScripts["Shield Cycler"]._sc_settings.general.disabled ) { return; };
    // checking if SC devices are active
    if ( worldScripts["Shield Cycler"]._sc_settings.general.sc_disabled ) { return; };
    worldScripts["Shield Cycler"]._sc_settings.sc.current_configuration = worldScripts["Shield Cycler"]._sc_settings.sc.start_configuration;
    var error = worldScripts["SC Core"]._sc_sc_adjust(true);
    if (error < 0 )
      {
	player.commsMessage( "Error - check latest log",10);
	log(this.name,"error while resetting to start configuration");
      };
  };
